use strict;
#------------------------------------------------------------------------------
# Linux jman/FreeBSD jman ˡץ饰
#                                                   (C)2006 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::TextParser::TagPlugin::Tag_jman;
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# 󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;	# ɤ߼Τ
	my $ROBJ  = shift;	# ɤ߼Τ

	my $tags = shift;
	$tags->{"linux:jman"}   = {data => \&linux_jman};
	$tags->{"freebsd:jman"} = {data => \&freebsd_jman, option => '5.4.0'};
}

###############################################################################
# 롼
###############################################################################
#------------------------------------------------------------------------------
# Linux manˡ
#------------------------------------------------------------------------------
sub linux_jman {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	my $section;
	my $search = shift(@$ary);
	if ($search =~ /^\d$/) {	# section ֹ
		$section = "&Sec$search=on";
		$search  = shift(@$ary);
	} else {
		$section = "&Sec1=on&Sec2=on&Sec3=on&Sec4=on&Sec5=on&Sec6=on&Sec7=on&Sec8=on";
	}
	# ѻʳ
	my $name = $search;
	$search =~ /[^\w\-\.]/g;
	# ̾
	if ($ary->[0] ne '') { $name=join(':', @$ary); }
	if (substr($name, 0, 5) eq 'title') { $name=substr($name, 6); }

	return "<a href=\"http://search.linux.or.jp/cgi-bin/JM/man.cgi?Pagename=$search$section\"$tag->{class}$tag->{title}>$name</a>";
}

#------------------------------------------------------------------------------
# FreeBSD manˡ
#------------------------------------------------------------------------------
sub freebsd_jman {
	my ($parser_obj, $tag, $cmd, $ary) = @_;

	my $release_ver = $tag->{option};
	my $section;
	my $search = shift(@$ary);
	if ($search =~ /^\d\.\d\.\d$/) {	# RELEASE Version
		$release_ver = $search;
		$search      = shift(@$ary);
	}
	if ($search =~ /^\d$/) {	# section ֹ
		$section = "&amp;sect=$search";
		$search  = shift(@$ary);
	}
	# ѻʳ
	my $name = $search;
	$search =~ /[^\w\-\.]/g;
	# ̾
	if ($ary->[0] ne '') { $name=join(':', @$ary); }
	if (substr($name, 0, 5) eq 'title') { $name=substr($name, 6); }

	return "<a href=\"http://www.jp.freebsd.org/cgi/mroff.cgi?subdir=man&lc=1&dir=jpman-$release_ver%2Fman&man=$search$section#toc\"$tag->{class}$tag->{title}>$name</a>";
}


1;
